Loading...
Searching...
No Matches
BALL::QSAR::PLSModel Class Reference

`#include <BALL/QSAR/plsModel.h>`

Inheritance diagram for BALL::QSAR::PLSModel:

## Public Member Functions

Constructors and Destructors
| PLSModel (const QSARData &q)
| ~PLSModel ()
Accessors
virtual void | train ()
virtual bool | optimizeParameters (int k, int no_steps)
void | setNoComponents (int no)
int | getNoComponents ()
const Eigen::MatrixXd * | getU ()
void | setParameters (vector< double > &v)
vector< double > | getParameters () const
Public Member Functions inherited from BALL::QSAR::LinearModel
| LinearModel (const QSARData &q)
| ~LinearModel ()
virtual void | operator= (const LinearModel &m)
virtual Eigen::VectorXd | predict (const vector< double > &substance, bool transform=1)
Public Member Functions inherited from BALL::QSAR::RegressionModel
| RegressionModel (const QSARData &q)
| ~RegressionModel ()
virtual EIGEN_MAKE_ALIGNED_OPERATOR_NEW void | operator= (const RegressionModel &m)
const Eigen::MatrixXd * | getTrainingResult () const
virtual void | saveToFile (string filename)
virtual void | readFromFile (string filename)
void | show ()
Public Member Functions inherited from BALL::QSAR::Model
| Model (const QSARData &q)
virtual | ~Model ()
virtual void | operator= (const Model &m)
void | copyData (const Model &m)
void | copyDescriptorIDs (const Model &m)
void | readTrainingData ()
void | deleteDescriptorIDs ()
bool | optimizeParameters (int k)
virtual double | calculateStdErr ()
std::multiset< unsigned int > * | getDescriptorIDs ()
void | setDataSource (const QSARData *q)
const Eigen::MatrixXd * | getDescriptorMatrix ()
const vector< string > * | getSubstanceNames ()
const vector< string > * | getDescriptorNames ()
const Eigen::MatrixXd | getDescriptorTransformations ()
const Eigen::MatrixXd | getYTransformations ()
const Eigen::MatrixXd * | getY ()
void | setDescriptorIDs (const std::multiset< unsigned int > &sl)
const string * | getType ()
void | getUnnormalizedFeatureValue (int compound, int feature, double &return_value)
void | getUnnormalizedResponseValue (int compound, int response, double &return_value)
Public Member Functions inherited from BALL::QSAR::LatentVariableModel
| LatentVariableModel ()
const Eigen::MatrixXd * | getLatentVariables ()
const Eigen::MatrixXd * | getWeights ()
const Eigen::MatrixXd * | getLoadings ()

## Protected Attributes

Attributes
Eigen::MatrixXd | U_
int | no_components_
Protected Attributes inherited from BALL::QSAR::RegressionModel
Eigen::MatrixXd | training_result_
Eigen::RowVectorXd | offsets_
int | default_no_opt_steps_
Eigen::MatrixXd | descriptor_matrix_
vector< string > | substance_names_
vector< string > | descriptor_names_
Eigen::MatrixXd | descriptor_transformations_
Eigen::MatrixXd | y_transformations_
Eigen::MatrixXd | Y_
String | type_
std::multiset< unsigned int > | descriptor_IDs_
Protected Attributes inherited from BALL::QSAR::LatentVariableModel
Eigen::MatrixXd | latent_variables_
Eigen::MatrixXd | loadings_
Eigen::MatrixXd | weights_

## Additional Inherited Members

RegressionValidation * | validation
const QSARData * | data
Validation * | model_val
void | calculateOffsets ()
void | readDescriptorInformationFromFile (std::ifstream &in, int no_descriptors, bool transformation, int no_coefficients)
void | saveDescriptorInformationToFile (std::ofstream &out)
Protected Member Functions inherited from BALL::QSAR::Model
void | readMatrix (Eigen::MatrixXd &mat, std::ifstream &in, unsigned int lines, unsigned int col)
void | readVector (Eigen::RowVectorXd &vec, std::ifstream &in, unsigned int no_cells, bool column_vector)
void | readModelParametersFromFile (std::ifstream &in)
void | saveModelParametersToFile (std::ofstream &out)
virtual void | readDescriptorInformationFromFile (std::ifstream &in, int no_descriptors, bool transformation)
void | readResponseTransformationFromFile (std::ifstream &in, int no_y)
void | saveResponseTransformationToFile (std::ofstream &out)
Eigen::VectorXd | getSubstanceVector (const vector< double > &substance, bool transform)
Eigen::VectorXd | getSubstanceVector (const Eigen::VectorXd &substance, bool transform)
void | backTransformPrediction (Eigen::VectorXd &pred)
void | addLambda (Eigen::MatrixXd &matrix, double &lambda)
void | readDescriptorInformation ()

## Detailed Description

Definition at line 28 of file plsModel.h.

## Constructor & Destructor Documentation

## PLSModel()

BALL::QSAR::PLSModel::PLSModel | ( | const QSARData & | q | ) |

constructur

Parameters

  q | QSAR-wrapper object, from which the data for this model should be taken

## ~PLSModel()

BALL::QSAR::PLSModel::~PLSModel | ( |  | ) |

## Member Function Documentation

## getNoComponents()

int BALL::QSAR::PLSModel::getNoComponents | ( |  | ) |

get the number of PLS components

## getParameters()

vector< double > BALL::QSAR::PLSModel::getParameters | ( |  | ) | const

virtual

Reimplemented from BALL::QSAR::Model.

## getU()

const Eigen::MatrixXd * BALL::QSAR::PLSModel::getU | ( |  | ) |

returns a pointer to the PLS Y-scores matrix U

## optimizeParameters()

virtual bool BALL::QSAR::PLSModel::optimizeParameters | ( | int | k,
|  | int | no_steps )

virtual

Tries to find the optimal number of PLS components (latente variables) for the current data of this model

Reimplemented from BALL::QSAR::Model.

Reimplemented in BALL::QSAR::OPLSModel.

## setNoComponents()

void BALL::QSAR::PLSModel::setNoComponents | ( | int | no | ) |

set the number of PLS components to create

## setParameters()

void BALL::QSAR::PLSModel::setParameters | ( | vector< double > & |  | ) |

virtual

sets the model parameters according to the given values.

Reimplemented from BALL::QSAR::Model.

## train()

virtual void BALL::QSAR::PLSModel::train | ( |  | ) |

virtual

Starts partial least squares regression.
In order to find the optimal number of latente variables for the current data of this model, run findNoLatenteVariables() first.

Implements BALL::QSAR::Model.

Reimplemented in BALL::QSAR::OPLSModel.

## Member Data Documentation

## no_components_

int BALL::QSAR::PLSModel::no_components_

protected

Definition at line 76 of file plsModel.h.

## U_

Eigen::MatrixXd BALL::QSAR::PLSModel::U_

protected

Definition at line 74 of file plsModel.h.